# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

from consts import *
from utilities import *

def loadSafeSitesPattern():
    lines = openFile('%ssafeSites' % CONF_PATH).readlines()


class GlobalObjects(object):
    '''Storing all global objects that need to be reloaded at some point, and
    do lazy initialization.'''
    
    def __init__(self):
        self.emailDBReadFlag = False

    
    def emailAddrPat(self):
        return re.compile(''.join(map((lambda l: l.rstrip()), open('%setc/rfc2822' % ENGINE_PATH))))

    emailAddrPat = Lazy(emailAddrPat)
    
    def emailAddrCommentPat(self):
        return re.compile('[ \t]*(?:\\([^\\\x80-\xff\n\r()]*(?:(?:\\[^\x80-\xff]|\\([^\\\x80-\xff\n\r()]*(?:\\[^\x80-\xff][^\\\x80-\xff\n\r()]*)*\\))[^\\\x80-\xff\n\r()]*)*\\)[ \t]*)*')

    emailAddrCommentPat = Lazy(emailAddrCommentPat)
    
    def prefs(self):
        return __import__('Preferences').Preferences('%sprefs' % CONF_PATH)

    prefs = Lazy(prefs)
    
    def htmlTags(self):
        return __import__('HTMLTagDict').HTMLTagDict('%shtmlTags' % CONF_PATH)

    htmlTags = Lazy(htmlTags)
    
    def safeSitesPattern(self):
        return loadSafeSitesPattern()

    safeSitesPattern = Lazy(safeSitesPattern)
    
    def siteDB(self):
        return __import__('SiteDB').SiteDB('%ssiteDB' % CONF_PATH, self.prefs.siteLimit)

    siteDB = Lazy(siteDB)
    
    def recipientPatterns(self):
        return __import__('SimplePatterns').SimplePatterns('%srecipientPatterns' % CONF_PATH)

    recipientPatterns = Lazy(recipientPatterns)
    
    def safeIPs(self):
        return __import__('SimplePatterns').SimplePatterns('%ssafeIPs' % CONF_PATH)

    safeIPs = Lazy(safeIPs)
    
    def whitelist(self):
        return __import__('SimplePatterns').SimplePatterns('%swhitelist' % CONF_PATH, True)

    whitelist = Lazy(whitelist)
    
    def metaPatterns(self):
        return __import__('MetaPatterns').MetaPatterns('%smetaPatterns' % CONF_PATH)

    metaPatterns = Lazy(metaPatterns)
    
    def addressSet(self):
        return __import__('addressBook').getAddressesFromABook()

    addressSet = Lazy(addressSet)
    
    def logger(self):
        return __import__('Logger').Logger('%sjm.log' % CONF_PATH)

    logger = Lazy(logger)
    
    def emailDB(self):
        return __import__('EmailDB').EmailDB('%semailDB.dat' % CONF_PATH, self.emailDBReadFlag)

    emailDB = Lazy(emailDB)

globalObjects = GlobalObjects()
if __name__ == '__main__':
    print globalObjects.addressSet

